/*		Match.m

		author	: jolly - who else ?
		version : 0.00
		date	: Sun Oct 30 23:22:53 MET 1994

*/


#import "Match.h"
#import "FastMatch.h"


@implementation Match

- init
{
	[super init];
	
	fastMatch=[[FastMatch alloc] init];

	return self;
}

- free
{
	[fastMatch free];
	return [super free];
}



- initFromFile:(const char *)filename
{
	[self init];
	[self readFromFile:filename];
	return self;
}

- readFromFile:(const char *)filename
{
	FILE *feil;
	u_char	momstr[MAXPATHLEN];
	u_char	*momaddr;
	u_char	**localstrings;
	u_char	**str;
	int i;
	
	localstrings=str=calloc(256,sizeof(char *));
	strcpy(*localstrings++=(u_char *)malloc(strlen(momstr)+1),"\n");
	strcpy(*localstrings++=(u_char *)malloc(strlen(momstr)+1),"\r");
		
	if(!(feil=fopen(filename,"r"))) return nil;
	while(!feof(feil))
	{
		momaddr=momstr;
		while( -1!=(i=getc(feil)) )
		{
			*momaddr=i;
			if( (*momaddr=='\r') || (*momaddr=='\n') )
			{
				if( momaddr!=momstr )
				{
					*momaddr=0;
					strcpy(*localstrings++=(u_char *)malloc(strlen(momstr)+1),momstr);
					momaddr=momstr;
				}
			}
			else
				momaddr++;
		}
		if(momaddr!=momstr)
		{
			*momaddr=0;
			strcpy(*localstrings++=(u_char *)malloc(strlen(momstr)+1),momstr);
			momaddr=momstr;
		}

	}
	fclose(feil);

	[fastMatch setMatchingStrings:str];
	localstrings=str;
	while(*localstrings++) free(*localstrings);
	free(str);
	
	return self;
}



- (int)matchBuffer:(void *)buffer size:(int)size
{
	int i;
	int len;
	
	u_char	matchinline=0;
	u_char num;
	
	[fastMatch setMatchBuffer:(u_char *)buffer size:(int)size];

	while( (i=[fastMatch match]) >=0 )
	{
		len=i>>8;
		num=(u_char)i;	
		
		if(num<2)						// 0==\r 1==\n
		{
			if( (!matchinline) && (len>1) ) return 0;
#ifdef DEBUG
			printf("matched return\n");
#endif
			matchinline=0;
		}
		else
		{
			matchinline=1;
#ifdef DEBUG
			printf("FastMatch :%d\n",num);
#endif
		}
	}
	switch(i)
	{
		case -1	:	return (int)matchinline;		// read something 
		case -2 :	return 1;						// didn't read anything
	}
	return 0;	// something went complettly wrong;
}


@end